#include <stdio.h>
#include <termios.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pthread.h>
#include <inttypes.h>
#include <sys/neutrino.h>

#include "wake.h"

const unsigned char
 FEND  = 0xC0,            //Frame END
 FESC  = 0xDB,            //Frame ESCape
 TFEND = 0xDC,            //Transposed Frame END
 TFESC = 0xDD;            //Transposed Frame ESCape



void* read_thread (void * parameter);
unsigned char RxByte (int fildes, void* buf,size_t nbyte,const uint64_t * ntime);
void DowCRC(unsigned char b, unsigned char &crc);
char progname []="Daemon WAKE" ;
struct	param
{
	 int fildes;
      void* buf;
      size_t nbyte;
};

/**************************************************************************************************/
/*																																		*/
/*		char * P - pointer to string-name port. Example: /dev/ser1															*/
/*		long baud - baud rate need																								*/
/*		return - file designator																									*/
/*																																		*/
/**************************************************************************************************/
int OpenCOM (char * P,long baud)
{
	int fdSer4=0 ;
	struct termios termios_ser;
  	struct termios*  LP_termios_ser=& termios_ser;
 	speed_t speed;
 	int fd;
 	char buffer[80];
 	int size_written=0;
 	int size_read=0;
 	
 	strcpy( buffer, P );
     strcat( buffer, ".speed" );
     for (size_written=0;size_written<80;size_written++)
     {
     	if(buffer[size_written]=='/')buffer[size_written]='_';
     }
     printf( "./%s\n", buffer );
     printf ("open ./%s file read only...",buffer);
 	fd=open( buffer, O_RDONLY );
 	if(fd==-1)
 	{
 		close (fd);
 		printf ("...false!\nopen ./%s file read and write and create...", buffer);
 		fd=open( buffer, O_RDWR  | O_CREAT );
 		if(fd!=-1)
 		{
 			printf ("... done.\n");
	 		size_written = write( fd,"57600\n",6 );
		    /* test for error              */
		    if( size_written != 6 ) {
		        perror( "Error writing in speed file!\n" );
		    }
		}
		else {printf ("...false!\n");}
		close (fd);
		printf ("open ./%s file read only...",buffer);
 		fd=open( buffer, O_RDONLY );
 		if(fd!=-1){printf ("... done.\n");}
 		else {printf ("... false!\n");}
 	}
 	else{printf ("... done.\n");}
 	
	// 	int errvalue;
 	// 1 proba open port
	fdSer4 =  open( P,O_RDWR);
	if(fdSer4==-1)
	{
		// port error
		// 2 proba open port after sleep 1 sec
		sleep(1);
		fdSer4 =  open( P,O_RDWR);
		if(fdSer4==-1)
		{
			// port error
			// 3 proba open port after sleep 1 sec
			sleep(1);
			fdSer4 =  open( P,O_RDWR);
			if(fdSer4==-1)
			{
				fprintf(stderr , "%s : PORT NOT OPEN : %s \n", progname , strerror( errno ));
				return fdSer4 ;
				// 3 proba open port is falure - exit.
			}
		}
	}
	fprintf(stderr , "%s : port open success \n", progname);
	size_read =  tcgetattr( fdSer4, LP_termios_ser );
	if (size_read!=0)
	{
		fprintf(stderr , "%s : can not get attribute of port : %s \n", progname , strerror( errno ));
	}
	 /*
	  *  Get input baud rate
	 */
	 speed = cfgetispeed( &termios_ser);
//	 printf( "Input baud: %ld\n", speed );
//	 fprintf(stderr , "%s : port '%s' curent baud: %ld\n", progname , P, speed );
	 /*
	 *	Set speed
	 */
	if (fd!=-1)
	{
		size_read = read( fd, buffer,sizeof( buffer ) );
	    /* Test for error */
	    if( size_read == -1 ) {
	        perror( "Error reading speed file\n" );
	        return EXIT_FAILURE;
	    }
		speed = atoi(buffer);
	}
	else
	{
		speed=baud;
	}
	printf ("set baud = %d\n",(int)speed);
	size_read =cfsetospeed( &termios_ser, speed );
	if (size_read!=0)
	{
		fprintf(stderr , "%s : can not set speed of port : %s \n", progname , strerror( errno ));
	}
	size_read =tcsetattr( fdSer4, TCSANOW, &termios_ser);
	if (size_read!=0)
	{
		fprintf(stderr , "%s : can not set attribute of port : %s \n", progname , strerror( errno ));
	}
	fprintf(stderr , "%s : done\n", progname);
	
	LP_termios_ser->c_iflag = LP_termios_ser->c_iflag & 0xFEFD ;
	LP_termios_ser->c_lflag = LP_termios_ser->c_lflag & 0xFF00;
	LP_termios_ser->c_cflag=0;
	LP_termios_ser->c_cflag=CREAD | CS8;// | PARENB ;//&(! PARODD)&(!CSTOPB )CLOCAL| ;
	size_read =  tcsetattr(fdSer4,TCSANOW  ,LP_termios_ser );
	if (size_read!=0)
	{
		fprintf(stderr , "%s : can not set attribute of port : %s \n", progname , strerror( errno ));
	}
	return fdSer4 ;
}
/**************************************************************************************************/
/*																																		*/
/*		int fd - file designator																										*/
/*																																		*/
/**************************************************************************************************/
int CloseCOM (int fd)
{
	int temp;
	temp=close(fd);
	if (temp)
	{
		fprintf(stderr , "%s : can not close of port : %s \n", progname , strerror( errno ));
	}
	else
	{
		fprintf(stderr , "%s : port close success \n", progname);
	}
	return temp;
}
/**************************************************************************************************/
/*																																		*/
/*		unsigned char ADDR - adress destination device 0 if adress ton need											*/
/*		unsigned char CMD - command																							*/
/*		unsigned char N - nimber byte message need transmite															*/
/*		unsigned char *data - pointer to massive message																	*/
/*		int fd - file designator openned port																					*/
/*																																		*/
/**************************************************************************************************/

unsigned char TxFrame(unsigned char ADDR, unsigned char CMD, unsigned char N,
                                                        unsigned char *Data, int fd)
{ 
	unsigned char Buff[518]; long r, j=0;
	unsigned char d, crc = 0xDE;              //init CRC
	int i;
//	FILE * fp;
/*	for (int i=0;i<518;i++)
	{
		Buff[i]=0;
	}*/
	for (i = -4; i <= N; i++)
	{
		if ((i == -3) && (!ADDR)) i++;			
		if (i == -4) d = FEND; else                 //FEND
		if (i == -3) d = ADDR; else                 //address
		if (i == -2) d = CMD;  else                 //command
		if (i == -1) d = N;    else                 //N
		if (i ==  N) d = crc;  else                 //CRC
		d = Data[i];                   //data
		DowCRC(d, crc);
		if (i == -3) d = d | 0x80;
		if (i > -4)
		if ((d == FEND) || (d == FESC))
		{ 
			Buff[j++] = FESC;
			if (d == FEND) d = TFEND;
			else d = TFESC;
		}
		Buff[j++] = d;
	}
// save in file
/*	fp = fopen ("/tmp/transmite.log","a");
	if(fp!=NULL)
	{
		for (i=0;i<j;i++)
		{fprintf (fp,"0x%02x ",Buff[i]);}
		fprintf(fp,"\n");
		fclose(fp);
	}*/
	r = write(fd , Buff , j); //TX frame
//	if(crc8 (Buff, j, 0xDE)==0) {printf ("packet send and CRC correct. crc = 0x%02x\n",d);}
//	else {printf ("packet send and CRC incorrect!!!!! crc = 0x%02x\n",d);}
	return (r==j);
}
/**************************************************************************************************/
/*																																		*/
/*		unsigned char *ADDR - adress variable keeping adress destination device									*/
/*		unsigned char *CMD - adress variable keeping command	resieved												*/
/*		unsigned char *N - number byte message ressieved																*/
/*		unsigned char *data - pointer to massive message																	*/
/*		uint64_t timeout_packet - time wait start of message																*/
/*		uint64_t timeout_disconnect - time wait new byte message inside message									*/
/*		int fd - file designator openned port																					*/
/*																																		*/
/**************************************************************************************************/

unsigned char  RxFrame (unsigned char * ADDR, unsigned char * CMD,
							   unsigned char * N, unsigned char *data, uint64_t timeout_packet,
								uint64_t timeout_disconnect, int fd)
{ 
	int iii;
	unsigned char ret;
	unsigned char Ack = 0, crc = 0xDE;          //init CRC
//	struct timespec start_byte, stop_byte;
    
	do{
		ret=RxByte (fd, &Ack,1,&timeout_packet);
		if(ret==SLAVE_NOT_RESPONSE){return SLAVE_NOT_RESPONSE;}}
	while (Ack!=FEND); //frame synchronzation
//	printf ("0x%02x ",Ack);
	DowCRC(Ack, crc);                               //update CRC
	*N = 0; *ADDR = 0;
	for (iii = -3; iii<=*N; iii++)
	{
		ret=RxByte (fd, &Ack,1,&timeout_disconnect);//printf ("0x%02x ",Ack);
		if(ret==SLAVE_NOT_RESPONSE){
			return SLAVE_NOT_RESPONSE;}
		if(Ack==FEND)
		{
			printf ("restart packet. 0xC0 code inside old packet\n");
			crc = 0xDE;
			DowCRC(Ack, crc);
			iii=-3;
			ret=RxByte (fd, &Ack,1,&timeout_disconnect);
			if(ret==SLAVE_NOT_RESPONSE){
			return SLAVE_NOT_RESPONSE;}
		}
		if (Ack == FESC)
		{
			ret=RxByte (fd, &Ack,1,&timeout_disconnect);printf ("0x%02x ",Ack);
			if(ret==SLAVE_NOT_RESPONSE){
				return SLAVE_NOT_RESPONSE;}
			if (Ack == TFEND){ Ack = FEND;}              //TFEND <- FEND
			else
			{
				if (Ack == TFESC) {Ack = FESC;}              //TFESC <- FESC
				else return NOT_WAKE_STREEM;
			}
		}
		if(iii == -3)
		{
			if ((Ack & 0x80) > 0) {
				 DowCRC((Ack & 0x7F), crc);
			}
			else
			{DowCRC(Ack, crc); }
		}
		else
		{
			DowCRC(Ack, crc);                             //update CRC
		}
		if (iii == -3)
			if ((Ack & 0x80) == 0) { *CMD = Ack; iii++; }     //CMD (b.7=0)
			else *ADDR = Ack & 0x7F;                      //ADD (b.7=1)
		else
		if (iii == -2)
			if ((Ack & 0x80) != 0) return NOT_WAKE_STREEM;//CMD error (b.7=1)
			else *CMD = Ack;                             //CMD
		else
		if (iii == -1)
		{
			*N = Ack;                                     //N
			if(*N>254)
			{
				return NOT_WAKE_STREEM;
			}
		}
		else
		if (iii !=  *N) *(data+iii) = Ack;                   //data
	}
	 //RX or CRC error
	if (!crc)
	{
		printf ("packet and CRC ok.\n");
		return OK;
	}
	else
	{
		printf ("packet and CRC bad!\n");
		return CRC_INCORRECT;
	}
}

/**************************************************************************************************/
/*																																		*/
/*		int fildes - file designator	for COM Port																					*/
/*		void* buf - pointer to buffer ressieve																					*/
/*		size_t nbyte - number byte need to ressieve																			*/
/*		const uint64_t * ntime - timeout waiting ressieve																	*/
/*																																		*/
/**************************************************************************************************/

unsigned char RxByte (int fildes, void* buf,size_t nbyte,const uint64_t * ntime)
{
	struct	sigevent	event;
	int err=0;
	SIGEV_UNBLOCK_INIT(&event);
	err=0;
	TimerTimeout(CLOCK_REALTIME, _NTO_TIMEOUT_SEND|_NTO_TIMEOUT_REPLY, &event , ntime, NULL) ;
	err=read(fildes,buf,nbyte);
	if(err== (int) nbyte)
	{
		return OK;
	}
	else
	{
		return SLAVE_NOT_RESPONSE;
	}
}
/**************************************************************************************************/
/*																																		*/
/*		iunsigned char *buf - pointer to buffer data																			*/
/*		unsigned int len - lenght data in to buffer																				*/
/*		unsigned char crc- first initialisation value																			*/
/*																																		*/
/**************************************************************************************************/
unsigned char crc8 (unsigned char *buf, unsigned int len, unsigned char crc)
{
	unsigned int i,j;
	unsigned char ret=crc,m,l;
	for (i=0;i<len;i++)
	{
		m=1;
		for (j=0;j<8;j++)
		{
			l=((buf[i]&m)?0x8c:0)^((ret&0x1)?0x8c:0);
			ret>>=1;
			ret^=l;
			m<<=1;
		}
	}
	return ret;
}
void DowCRC(unsigned char b, unsigned char &crc)
{ for (int i = 0; i < 8; i++)
  {
   if (((b ^ crc) & 1) != 0)
     crc = ((crc ^ 0x18) >> 1) | 0x80;
       else crc = (crc >> 1) & ~0x80;
   b = b >> 1;
   }
}
